do
local oldModBP = ModBlueprints

function ModBlueprints(all_bps)

    oldModBP(all_bps)
	
    for id,bp in all_bps.Unit do
		if bp.Veteran then
			local list = false
			local structure = false
			
			local weaponAdd = 0
			local techAdd = 1
			for i, cat in bp.Categories do
				if cat == 'EXPERIMENTAL' then
					techAdd = 125
				elseif cat == 'COMMAND' then
					techAdd = 30
				elseif cat == 'TECH3' then
					techAdd = 25
				elseif cat == 'TECH2' then
					techAdd = 10
				elseif cat == 'TECH1' then
					techAdd = 1
				end
				if cat == 'STRUCTURE' then
					if bp.Weapon then
						weaponAdd = math.pow(bp.Weapon[1].MaxRadius, 0.45) + 15
						structure = true
					end
				else
					if bp.Weapon and not structure then
						weaponAdd = math.pow(bp.Weapon[1].MaxRadius, 0.8)/2 - 2
					end
				end

				--[[if string.sub(bp.BlueprintId, 2, 2) == 'a' and cat == 'TECH3' then
				if cat == 'EXPERIMENTAL' or cat == 'COMMAND' then
					LOG('-------------------------------------')
					local name = string.gsub(bp.Description, '<(.*)>(.*)', '%2')
					LOG(name)
					LOG('Old: ', repr(bp.Veteran))
					list = true
				end]]
			end
			for i in bp.Veteran do
				local level = 1
				if i == 'Level5' then
					level = 5
				elseif i == 'Level4' then
					level = 4
				elseif i == 'Level3' then
					level = 3
				elseif i == 'Level2' then
					level = 2
				elseif i == 'Level1' then
					level = 1
				end
				bp.Veteran[i] = math.floor(level*(weaponAdd + techAdd))
			end
			--[[if list then
				--LOG('WeaponAdd/TechAdd: ' .. weaponAdd .. '/' ..techAdd)
				LOG('New: ', repr(bp.Veteran))
			end]]
		end 
	end
end
end
